--- gtk-vnc-0.3.5/src/gvnc.c	2008-04-06 15:35:22.000000000 -0700
+++ gtk-vnc-mine/src/gvnc.c	2008-04-08 15:59:54.000000000 -0700
@@ -1858,6 +1858,18 @@
 	}
 }
 
+
+static void gvnc_pointer_pos_change(struct gvnc *gvnc, int x, int y)
+{
+	if(gvnc->has_error || !gvnc->ops.pointer_pos_change)
+                return;
+	if (!gvnc->ops.pointer_pos_change(gvnc->ops_data, x, y)) 
+	{
+                GVNC_DEBUG("Closing the connection: gvnc_pointer_pos_change\n");
+                gvnc->has_error = TRUE;
+        }
+}
+
 static void gvnc_rich_cursor_blt(struct gvnc *gvnc, uint8_t *pixbuf,
 				 uint8_t *image, uint8_t *mask,
 				 int pitch, uint16_t width, uint16_t height)
@@ -1865,6 +1877,8 @@
 	gvnc->rich_cursor_blt(gvnc, pixbuf, image, mask, pitch, width, height);
 }
 
+
+
 static void gvnc_rich_cursor(struct gvnc *gvnc, int x, int y, int width, int height)
 {
 	uint8_t *pixbuf = NULL;
@@ -2021,6 +2035,9 @@
 	case GVNC_ENCODING_EXT_KEY_EVENT:
 		gvnc->has_ext_key_event = TRUE;
 		break;
+	case GVNC_ENCODING_CURSOR_POS:
+		gvnc_pointer_pos_change(gvnc, x, y);
+		break;
 	default:
 		GVNC_DEBUG("Received an unknown encoding type: %d\n", etype);
 		gvnc->has_error = TRUE;
@@ -2046,6 +2063,8 @@
 		}
 	} while ((ret = gvnc_read_u8_interruptable(gvnc, &msg)) == -EAGAIN);
 
+	GVNC_DEBUG("Got char %d for message type.\n", msg);
+
 	if (ret < 0) {
 		GVNC_DEBUG("Aborting message processing on error\n");
 		return !gvnc_has_error(gvnc);
@@ -2056,7 +2075,7 @@
 		uint8_t pad[1];
 		uint16_t n_rects;
 		int i;
-
+GVNC_DEBUG("Framebuffer update.");
 		gvnc_read(gvnc, pad, 1);
 		n_rects = gvnc_read_u16(gvnc);
 		for (i = 0; i < n_rects; i++) {
@@ -2077,7 +2096,7 @@
 		uint16_t n_colors;
 		uint8_t pad[1];
 		int i;
-
+GVNC_DEBUG("Colormap entries");
 		gvnc_read(gvnc, pad, 1);
 		first_color = gvnc_read_u16(gvnc);
 		n_colors = gvnc_read_u16(gvnc);
@@ -2095,13 +2114,14 @@
 		}
 	}	break;
 	case 2: /* Bell */
+GVNC_DEBUG("Bell.");
 		gvnc_bell(gvnc);
 		break;
 	case 3: { /* ServerCutText */
 		uint8_t pad[3];
 		uint32_t n_text;
 		char *data;
-
+GVNC_DEBUG("Server cut text.");
 		gvnc_read(gvnc, pad, 3);
 		n_text = gvnc_read_u32(gvnc);
 		if (n_text > (32 << 20)) {
